We first describe numerical tests that show how well the model fits the data.  We then provide some detailed analysis and insights learned from examining the \texttt{ArrayList} clusters.

\subsection{The number of underlying Markov Chains}
To investigate the problem of determining how many underlying mixtures to choose, we split our data into 90\% training and 10\% test.  (Performing $n$-fold cross-validation would have been better if time had permitted).  We then ran our learning algorithm for different values of $k$, noting the training likelihood and test likelihood.  Because the EM algorithm is sensitive to initialization, we chose models with the best training likelihood over 5 random initial starting points.  We also included the BIC score to compare it with test set performance.  For the BIC score, the dimension of a mixture of $k$ components has $k-1$ parameters for the prior and if $n$ is the number of possible states, $n-1$ parameters for the initial probabilities and $n^2$ parameters for the transition probabilities (since we have an end state, this is $n^2$ rather than $n(n-1)$.)  We show our results in Table~\ref{table:crossresults}.

\begin{table}
\small{
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
$k$ & training log likelihood & test log likelihood & number of parameters & BIC score for training data\\
\hline
2 & -12090 & -1295 & 143 & -12673 \\
4 & -10112 & -1078 & 287 & -11284 \\
6 & -9268 & -991 & 431 & -11028 \\
8 & -9214 & -989 & 575 & -11562 \\
10 & -9207 & -988 & 719 & -12143 \\
\hline
\end{tabular}
}
\caption{Cross-validation results.}
\label{table:crossresults}
\end{table}

The data shows that $k=6$ is the first $k$ value to yield a close to maximal test log likelihood.  The BIC score agrees that this is the best choice for number of underlying clusters.  One observation of note is that we do not seem to have an over-training problem in terms of the classical increase in test error.  One possible explanation for this phenomena is that our training set was much larger than our test set, though it is possible that we would start seeing more over-training for even larger values of $k$.

\subsection{Relationship between programs and clusters}
If clusters map traces back to their original programs, then this suggests different programs have different patterns of interactions; if not, then this suggests there may be some common patterns of interaction.

To examine this, we determined the best cluster for each training sample (by taking the cluster with the highest $p(z | x)$) and grouped these mappings by program.  The data (Table~\ref{table:bestclust}) shows that that there was a single dominant cluster composed of samples from every program.  It appears that the identity of the program was not a strong determinant of the type of trace or interaction, and rather, there was a single dominant way of interacting with the API that was consistent across programs.  This held true across different choices of $k$, hinting that adding more mixture components would simply refine our performance on the rarer edge cases.

\begin{table}
\centering
{\small
\begin{tabular}{|c|c|c|c|c|}
\hline
program & best cluster & number in best cluster &  \% in best cluster & prior of best cluster\\
\hline
mallet-import & 2 & 29 & 0.66 & 0.43 \\
mallet-train & 2 & 23 & 0.79 & 0.43 \\
jweather & 2 & 2203 & 0.80 & 0.43 \\
mallet-evaluate & 2 & 23 & 0.79 & 0.43 \\
lucene-index & 2 & 232 & 0.34 & 0.43 \\
\hline
\end{tabular}
\begin{tabular}{|c|c|c|c|c|}
\hline
program & best cluster & number  in best cluster &  \% in best cluster & prior of best cluster\\
\hline
mallet-import & 5 & 28 & 0.64 & 0.47 \\
mallet-train & 5 & 23 & 0.79 & 0.47 \\
jweather & 5 & 2212 & 0.81 & 0.47 \\
mallet-evaluate & 5 & 23 & 0.79 & 0.47 \\
lucene-index & 5 & 342 & 0.50 & 0.47 \\
\hline
\end{tabular}
}
\caption{Best Clusters for $k=4, 6$, respectively.}
\label{table:bestclust}
\end{table}
